<template>
  <div v-if="data.empty" class="empty"></div>
  <div v-else class="event-card" @click="clickEvent(data.id)">
    <div class="image">
      <img ref="img-container" height="100%" width="100%" src="@/assets/camera.png" alt="">
    </div>
    <div class="info">
      <div class="title">{{ data.title }}</div>
      <div class="short-desc">{{ data.shortDescription }}</div>
      <div>
        <span class="author">{{ data.author && data.author.firstName }} {{ data.author && data.author.lastName }}</span>
        &nbsp;
        <span class="place">{{ data.location }}</span>
      </div>
      <div class="rating">
        <StarRating :rating="data.rating" />
      </div>
      <div class="paid">{{ (data.price && `${data.price} kzt`) || '0 kzt' }}</div>
    </div>
  </div>
</template>
<script>
import axios from 'axios'
import StarRating from './StarRating'
export default {
  name: 'EventCard',
  components: {
    StarRating
  },
  props: {
    data: {
      type: Object,
      default: () => ({
        empty: true
      })
    }
  },
  watch: {
    data (dt) {
      if (!dt.empty) {
        const self = this
        axios.get(`http://localhost:9192/image/get/${dt.imageName}`)
          .then(response => {
            var blob = response.data.picture
            const imageUrl = `data:image/png;base64,${blob}`
            self.$refs['img-container'].src = imageUrl
          }).catch(err => {
            console.error('error loading image', err)
            self.$refs['img-container'].src = require(`@/assets/camera.png`)
          })
      }
    }
  },
  methods: {
    clickEvent (id) {
      this.$router.push(`/events/${id}`)
    }
  }
}
</script>
<style lang="scss" scoped>
.empty {
  max-width: 256px;
  width: 100%;
  height: 265px;
}
.event-card {
  max-width: 280px;
  width: 100%;
  height: 265px;
  background: #FFFFFF;
  box-shadow: 0px 16px 24px rgba(0, 0, 0, 0.08);
  border-radius: 6px;
  overflow: hidden;
  cursor: pointer;
  .image {
    height: 130px;
    background: white;
    margin-bottom: 10px;
    img {
      object-fit: cover;
    }
  }
  .info {
    text-align: start;
    padding-left: 10px;
    padding-right: 10px;
    .title {
      font-family: $base_font;
      font-weight: normal;
      font-size: 14px;
      // line-height: 19px;
      // height: 15px;
      color: #0A1034;
      white-space: nowrap;
      overflow: hidden;
      text-overflow: ellipsis;
      margin-bottom: 5px;
    }
    .short-desc {
      font-size: 11px;
      height: 30px;
      overflow: hidden;
      text-overflow: ellipsis;
    }
    .author {
      font-family: Montserrat;
      font-style: normal;
      font-weight: normal;
      font-size: 10px;
      line-height: 22px;
      color: #222222;
      margin-bottom: 14px;
    }
    .place {
      font-family: Montserrat;
      font-style: normal;
      font-weight: 500;
      font-size: 10px;
      line-height: 22px;
      color: #222222;
      border-bottom: 1px solid black;
    }
    .rating {
      height: 10px;
      margin-bottom: 10px;
    }
    .paid {
      font-family: Montserrat;
      font-style: normal;
      font-weight: 600;
      font-size: 14px;
      line-height: 17px;
      color: #5FA1DE;
    }
  }

}
</style>
